package tests.hornetq;

import java.util.Hashtable;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.InvalidClientIDException;
import javax.naming.Context;
import javax.naming.InitialContext;

import junit.framework.TestCase;

public class TestHornetqDuplicateClientID extends TestCase {

    protected InitialContext ic;
    protected ConnectionFactory cf;

    protected void setUp() throws Exception {

        super.setUp();

        Hashtable<String, String> env = new Hashtable<String, String>();

        env.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
        env.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
        env.put(Context.PROVIDER_URL, "jnp://localhost:1099");

        ic = new InitialContext(env);

        cf = (ConnectionFactory) ic.lookup("/ConnectionFactory");
        
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void testDuplicate() throws Exception {

        Connection c1 = null;
        Connection c2 = null;
        try {

            c1 = cf.createConnection();
            c1.setClientID("Duplicated");

            try {
                c2 = cf.createConnection();
                c2.setClientID("Duplicated");
                fail("HornetQ is allowing duplicate clients!");
            } catch (InvalidClientIDException e) {
            }
        } finally {
            if (c1 != null)
                c1.close();
            if (c2 != null)
                c2.close();
        }

    }

}
